/*
 Created by Peter Guijt on July 10, 2015
 using code examples from: Nitin William and Rui Santos, who both created Arduino based ethernet switch controllers

 Hardware requirements:
 Arduino Mega 2560 with A5100 Ethernet Shield and 8 relay module
 code is based on relay module that activates by shorting to ground, so LOW is ON and HIGH is OFF
 
 
 Visit: http://randomnerdtutorials.com for more arduino projects
 */

#include <SPI.h>
#include <Ethernet.h>
 
int relay1 = 31; //Arduino Mega pin 31
int relay2 = 32;
int relay3 = 33;
int relay4 = 34;
int relay5 = 35;
int relay6 = 36;
int relay7 = 37;
int relay8 = 38; //Arduino Mega pin 38
 
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };   //physical mac address
EthernetServer server(18033);                          //server port     

String readString;
String wjason;

void setup() {
  delay(500);// Delay for Ethernet shield initialization (Arduino has 65mS Power Up delay and W5100 reset logic has 280mS)
  // Open serial communications and wait for port to open:
  Serial.begin(57600); //300, 600, 1200, 2400, 4800, 9600, 14400, 19200, 28800, 38400, 57600, or 115200
    
  pinMode(relay1, OUTPUT);
  pinMode(relay2, OUTPUT);
  pinMode(relay3, OUTPUT);
  pinMode(relay4, OUTPUT);
  pinMode(relay5, OUTPUT);
  pinMode(relay6, OUTPUT);
  pinMode(relay7, OUTPUT);
  pinMode(relay8, OUTPUT);
  //
  //Pins 10,11,12 & 13 are used by the ethernet shield
  //

  // switch all relays off on init
  digitalWrite(relay1, HIGH); //HIGH for off, LOW for on, relay switches on to ground
  digitalWrite(relay2, HIGH);
  digitalWrite(relay3, HIGH);
  digitalWrite(relay4, HIGH);
  digitalWrite(relay5, HIGH);
  digitalWrite(relay6, HIGH);
  digitalWrite(relay7, HIGH);
  digitalWrite(relay8, HIGH);
  
  // start the Ethernet connection and the server:
  Ethernet.begin(mac); //dhcp
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
}


void loop() {
  // Create a client connection
  EthernetClient client = server.available();
  if (client) {
    while (client.connected()) {   
      if (client.available()) {
        char c = client.read();
     
        //read char by char HTTP request
        if (readString.length() < 100) {
          //store characters to string
          readString += c;
          //Serial.print(c);
         }

         //if HTTP request has ended
         if (c == '\n') {          
           Serial.println(readString); //print to serial monitor for debuging
     
           client.println("HTTP/1.1 200 OK"); //send new page
           client.println("Content-Type: text/html");
           client.println();     
           client.println("<HTML>");
           client.println("<HEAD>");
           client.println("<meta name='apple-mobile-web-app-capable' content='yes' />");
           client.println("<meta name='apple-mobile-web-app-status-bar-style' content='black-translucent' />");
           client.println("<link rel='stylesheet' type='text/css' href='http://randomnerdtutorials.com/ethernetcss.css' />");
           client.println("<TITLE>Home Cinema Control</TITLE>");
           client.println("</HEAD>");
           client.println("<BODY>");
           client.println("<H1>Home Cinema Control</H1>");
           client.println("<hr />");
           client.println("<br />");  
           client.println("<H2>Environmental Control</H2>");
           client.println("<br />");  
           client.println("<a href=\"/?switch1off\"\">Turn Off</a>");
           client.println("<a href=\"/?switch1on\"\">Turn On Switch 1</a><br />");   
           client.println("<br />");     
           client.println("<br />"); 
           client.println("<a href=\"/?switch2off\"\">Turn Off</a>");
           client.println("<a href=\"/?switch2on\"\">Turn On Switch 2</a><br />");   
           client.println("<br />");     
           client.println("<br />");
           client.println("<a href=\"/?switch3off\"\">Turn Off</a>");
           client.println("<a href=\"/?switch3on\"\">Turn On Switch 3</a><br />");   
           client.println("<br />");     
           client.println("<br />");
           client.println("<a href=\"/?switch4off\"\">Turn Off</a>");
           client.println("<a href=\"/?switch4on\"\">Turn On Switch 4</a><br />");   
           client.println("<br />");     
           client.println("<br />");
           client.println("<a href=\"/?switch5off\"\">Turn Off</a>");
           client.println("<a href=\"/?switch5on\"\">Turn On Switch 5</a><br />");   
           client.println("<br />");     
           client.println("<br />");
           client.println("<a href=\"/?switch6off\"\">Turn Off</a>");
           client.println("<a href=\"/?switch6on\"\">Turn On Switch 6</a><br />");   
           client.println("<br />");     
           client.println("<br />");
           client.println("<a href=\"/?switch7off\"\">Turn Off</a>");
           client.println("<a href=\"/?switch7on\"\">Turn On Switch 7</a><br />");   
           client.println("<br />");     
           client.println("<br />");
           client.println("<a href=\"/?switch8off\"\">Turn Off</a>");
           client.println("<a href=\"/?switch8on\"\">Turn On Switch 8</a><br />");   
           client.println("<br />");     
           client.println("<br />");
           client.println("<p>Created by Peter Guijt - 2015-07-10</p>");  
           client.println("<p>Arduino Mega 2560 with Ethernet Shield</p>"); 
           client.println("<br />"); 
           client.println("</BODY>");
           client.println("</HTML>");
     
           delay(1);
           //stopping client
           client.stop();
           
           //controls the Arduino if you press the buttons
           if (readString.indexOf("?switch1on") >0){
               digitalWrite(relay1, LOW);
               wjason = "{relay1 on}";
               writejson();
           }
           if (readString.indexOf("?switch1off") >0){
               digitalWrite(relay1, HIGH);
               wjason = "{relay1 off}";
               writejson();
           }
           if (readString.indexOf("?switch2on") >0){
               digitalWrite(relay2, LOW);
               wjason = "{relay2 on}";
               writejson();
           }
           if (readString.indexOf("?switch2off") >0){
               digitalWrite(relay2, HIGH);
               wjason = "{relay2 off}";
               writejson();
           }
           if (readString.indexOf("?switch3on") >0){
               digitalWrite(relay3, LOW);
               wjason = "{relay3 on}";
               writejson();
           }
           if (readString.indexOf("?switch3off") >0){
               digitalWrite(relay3, HIGH);
               wjason = "{relay3 off}";
               writejson();
           }
           if (readString.indexOf("?switch4on") >0){
               digitalWrite(relay4, LOW);
               wjason = "{relay4 on}";
               writejson();
           }
           if (readString.indexOf("?switch4off") >0){
               digitalWrite(relay4, HIGH);
               wjason = "{relay4 off}";
               writejson();
           }
           if (readString.indexOf("?switch5on") >0){
               digitalWrite(relay5, LOW);
               wjason = "{relay5 on}";
               writejson();
           }
           if (readString.indexOf("?switch5off") >0){
               digitalWrite(relay5, HIGH);
               wjason = "{relay5 off}";
               writejson();
           }
           if (readString.indexOf("?switch6on") >0){
               digitalWrite(relay6, LOW);
               wjason = "{relay6 on}";
               writejson();
           }
           if (readString.indexOf("?switch6off") >0){
               digitalWrite(relay6, HIGH);
               wjason = "{relay6 off}";
               writejson();
           }
           if (readString.indexOf("?switch7on") >0){
               digitalWrite(relay7, LOW);
               wjason = "{relay7 on}";
               writejson();
           }
           if (readString.indexOf("?switch7off") >0){
               digitalWrite(relay7, HIGH);
               wjason = "{relay7 off}";
               writejson();
           }
           if (readString.indexOf("?switch8on") >0){
               digitalWrite(relay8, LOW);
               wjason = "{relay8 on}";
               writejson();
           }
           if (readString.indexOf("?switch8off") >0){
               digitalWrite(relay8, HIGH);
               wjason = "{relay8 off}";
               writejson();
           }
            //clearing string for next read
            readString="";  
           
         }
       }
    }
  }
}

void writejson(){
  EthernetClient client2 = server.available();
  while (client2.connected()) {   
      if (client2.available()) {
        client2.println(wjason);
        client2.stop();
      }
  }
  wjason = "";
}


